const NS_COPYLINKER = "http://gita.club.fr/mozilla/copylinker-rdf#";

function copyLinkerSite(aID)
{
        this.id     = aID;
        this.visitNb = 1;
        this.visitDate = "";
        this.title   = "";
        this.comment = "";
};


/**
 * Var allowing copylinker to access easily to different Mozilla Services
 */
var CLservice = {
    RDF    : Components.classes['@mozilla.org/rdf/rdf-service;1']
               .getService(Components.interfaces.nsIRDFService),
    RDFC   : Components.classes['@mozilla.org/rdf/container;1']
               .getService(Components.interfaces.nsIRDFContainer),
    RDFCU  : Components.classes['@mozilla.org/rdf/container-utils;1']
               .getService(Components.interfaces.nsIRDFContainerUtils),
    DIR    : Components.classes['@mozilla.org/file/directory_service;1']
               .getService(Components.interfaces.nsIProperties),
    IO     : Components.classes['@mozilla.org/network/io-service;1']
               .getService(Components.interfaces.nsIIOService),
    UC     : Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
               .getService(Components.interfaces.nsIScriptableUnicodeConverter),
    WM     : Components.classes['@mozilla.org/appshell/window-mediator;1']
               .getService(Components.interfaces.nsIWindowMediator),
    PB     : Components.classes['@mozilla.org/preferences;1']
               .getService(Components.interfaces.nsIPrefBranch),
    PS     : Components.classes['@mozilla.org/preferences-service;1']
               .getService(Components.interfaces.nsIPrefService )
};



var CLcommon = {

	/**
     * Get user's profile extention directory.
     * If the copylinker doesn't exist we create it
     * else returns it
     */
    getCopyLinkerDir : function()
    {
        var myDataDir = CLservice.DIR.get("ProfD", Components.interfaces.nsIFile);
        myDataDir.append("copylinker");
        if ( !myDataDir.exists() )
        {
            myDataDir.create(myDataDir.DIRECTORY_TYPE, 0700);
        }
        return myDataDir;
    },

    loadURL : function(aURL, tabbed)
    {
        var topWindow = CLservice.WM.getMostRecentWindow("navigator:browser");
        var myBrowser = topWindow.document.getElementById("content");
        if ( tabbed ) {
            myBrowser.selectedTab = myBrowser.addTab(aURL);
        } else {
            myBrowser.loadURI(aURL);
        }
    },

       
    getTimeStamp : function(advance)
    {
        var dd = new Date;
        if ( advance ) dd.setTime(dd.getTime() + 1000 * advance);
        var y = dd.getFullYear();
        var m = dd.getMonth() + 1; if ( m < 10 ) m = "0" + m;
        var d = dd.getDate();      if ( d < 10 ) d = "0" + d;
        var h = dd.getHours();     if ( h < 10 ) h = "0" + h;
        var i = dd.getMinutes();   if ( i < 10 ) i = "0" + i;
        var s = dd.getSeconds();   if ( s < 10 ) s = "0" + s;
        return y.toString() + m.toString() + d.toString() + h.toString() + i.toString() + s.toString();
    },


    getFocusedWindow : function()
    {
        var myWindow = document.commandDispatcher.focusedWindow;
        if ( !myWindow || myWindow == window ) myWindow = window._content;
        return myWindow;
    }
};
