window.addEventListener("load", refreshMenus, true);
window.addEventListener("load", refreshCLContextMenu, true);
window.addEventListener("load", refreshCLMainMenu, true);
window.addEventListener("load", refreshCLGoMenu, true);


var dataOrigin;
var dataEnd;

const preferencesService = CLservice.PS.getBranch("");

/**
 * Grab data about the page where the copy occurs :
 * url, title, visitDate
 */
function handleCopy(event) {
    var copiedText = getClipboardData();
    var aDocShell = document.getElementById("content").webNavigation;
    var url = aDocShell.currentURI.spec;
    url= url.split('?')[0];
    var title = aDocShell.document.title;
    
    dataOrigin = new copyLinkerSite(url);
    dataOrigin.title = title;
    dataOrigin.visitDate = new Date ();
    //dump ('copy : ' + copiedText + ', ' + dataOrigin.title + '\n');
    
    preferencesService.setCharPref("copylinker.url", url);
    preferencesService.setCharPref("copylinker.title", title);   
    preferencesService.setCharPref("copylinker.date", new Date());
}

/**
 * Grab data about the page where the cut occurs :
 * url, title, visitDate
 */
function handleCut(event) {
    var url = document.commandDispatcher.focusedWindow.document.URL;
	dataOrigin = new copyLinkerSite(url.split('?')[0]);
    dataOrigin.title = document.commandDispatcher.focusedWindow.document.title;
    dataOrigin.visitDate = new Date ();
    
//    dump ( 'cut : ' + getClipboardData () + ', ' 
//           + document.commandDispatcher.focusedWindow.document.title
//           + '\n');
}

/**
 * Grab data about the page where the paste occurs :
 * url, title, visitDate
 * And call the function which handles the data.
 */
function handlePaste (event) {
    var aDocShell = document.getElementById("content").webNavigation;
    var url = aDocShell.currentURI.spec;
    url= url.split('?')[0];
    var title = aDocShell.document.title;

    dataEnd = new copyLinkerSite(url);
    dataEnd.title = title;
    dataEnd.visitDate = new Date();
	
//    dump ('paste : ' + getClipboardData () + ', ' + titre + '\n');
    saveCopyPaste() ;
}


/**
 * Grab data contained in the clipboard
 */
function getClipboardData ( ) {
    var text = new String("");

    /* clipboard interface */    
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"]
                    .createInstance(Components.interfaces.nsIClipboard);
    if (!clip) return false;

    /* used to transfer the data */
    var trans = Components.classes["@mozilla.org/widget/transferable;1"]
                    .createInstance(Components.interfaces.nsITransferable);
    if (!trans) return false;
    trans.addDataFlavor("text/unicode");

    clip.getData(trans,clip.kGlobalClipboard);

    var str = new Object();
    var strLength = new Object();

    trans.getTransferData("text/unicode",str,strLength);
    
    if (str)
        str=str.value.QueryInterface(Components.interfaces.nsISupportsString);
    if (str)
        text = str.data.substring(0,strLength.value / 2);
        
    return text;
}


/**
 * 
 */
function saveCopyPaste() {
    var dossierCL = CLcommon.getCopyLinkerDir () ;
    CLRDF.init();
    dump('init done\n');
//    if (dataOrigin) {
//      dump('dataOrigin!=null\n : ' + dataOrigin.title);
//      CLRDF.addItem (dataOrigin, dataEnd);
//    } else
    if (preferencesService.prefHasUserValue("copylinker.url")) {
      //dump('dataOrigin==null\n');
      var url = preferencesService.getCharPref("copylinker.url");
      var title = preferencesService.getCharPref("copylinker.title");
      var date = preferencesService.getCharPref("copylinker.date");
      
      dataOrigin = new copyLinkerSite(url);
      dataOrigin.title = title;
      dataOrigin.visitDate = date;
      CLRDF.addItem (dataOrigin, dataEnd);
    } else
      dump("Copy error, there is no trace of copied data\n\n"
           + "- You either pasted before you did any copy in Firefox \n"
           + "- Or you copied data by selecting it (on Linux)\n\n"
           + "To avoid errors no shotcut will be created\n");

    refreshMenus(null);
    //free the memory
    CLRDF.data = null;
}


function launch(url) {
    
    var urlSource = new String(document.commandDispatcher.focusedWindow.document.URL);
    var dataSource = new copyLinkerSite(urlSource.split('?')[0]);
    var dataTarget = new copyLinkerSite(url.split('?')[0]);
    
    var dossierCL = CLcommon.getCopyLinkerDir () ;
    CLRDF.init();
    var res = CLRDF.addMenuItem (dataSource, dataTarget);
    CLRDF.data = null;
//    dump("launch " + urlSource + " : " + urlSource.split('?')[0] + "\n -> " 
//         + url + " : " + url.split('?')[0] + "\n used : " + res + "\n");
    
    _content.location.href = url;   
}


function refreshCLMenu(rdfMenu) {
    var url; 
    if (document.commandDispatcher.focusedWindow) {
      url = new String(document.commandDispatcher.focusedWindow.document.URL);
      //dump("focus\n");
    }
    //dump (url + " " + typeof url + "\n" + _content.location.href + "\n");
    
    if (url == 'undefined')
      url = _content.location.href;
      
    if (!url) {
      //dump ("urlbar\n");
      url = document.getElementById("urlbar").value;
    }

    url = url.split('?')[0];
    //if (!url) {
      try {
        rdfMenu.ref = "urn:copylinker:copy" + url;
        //dump("Attribute ref : " + rdfMenu.getAttribute("ref") + "\n");
      }
      catch(ex) {
        alert("Copylinker ERROR: Failed to set ref Attribute.\n\n" 
              + ex);
      }    
    //}
    
    //dump("url : " + url);
    CLRDF.init();
    rdfMenu.database.AddDataSource(CLRDF.data);
    rdfMenu.builder.rebuild();
    if (url) 
    try {
	    //dump ("copy : " + CLservice.RDF.GetResource("urn:copylinker:copy" + url) + "\n");
	    var copyRessource = CLservice.RDF.GetResource("urn:copylinker:copy" + url);
	    var aSeqCopy = CLservice.RDFCU.MakeSeq(CLRDF.data, copyRessource);
	    var nbElements = aSeqCopy.GetCount();
	    //dump ("copy : " + nbElements + "\n");
	    if (nbElements == 0) {
	      document.getElementById("shortcutsContextMenu").setAttribute('disabled','true');
	      //document.getElementById("shortcutsMainMenu").setAttribute('disabled','true');
	      document.getElementById("shortcutsGoMenu").setAttribute('disabled','true');
	    }
	    else {
	      document.getElementById("shortcutsContextMenu").setAttribute('disabled','false');
	      //document.getElementById("shortcutsMainMenu").setAttribute('disabled','false');
	      document.getElementById("shortcutsGoMenu").setAttribute('disabled','false');
	    }
    } catch(ex) {
      dump("Copylinker ERROR: Failed to count urn:copylinker:copy" + url 
           + ".\n" +  ex + "\n");
    }
}

function refreshCLContextMenu(event)
{
//    var controller = top.document.commandDispatcher.getControllerForCommand('cmd_copy');
//    if ( controller && controller.isCommandEnabled('cmd_copy')) alert(controller);

    refreshCLMenu( document.getElementById("shortcutsContextMenu") ) ;
}


function refreshCLGoMenu(event)
{
    refreshCLMenu( document.getElementById("shortcutsGoMenu") ) ;
}


function refreshCLMainMenu(event)
{
    refreshCLMenu( document.getElementById("shortcutsMainMenu") ) ;
}

function refreshMenus(event)
{
  var browser = document.documentElement;
  browser.addEventListener("keypress", onKeyPress, true);
		
  var clContextMenu = document.getElementById("contentAreaContextMenu");
  var clMainMenu = document.getElementById("shortcutsMainMenu");
  var clGoMenu = document.getElementById("goPopup");
  
  clContextMenu.addEventListener("popupshowing", refreshCLContextMenu, true);
  clMainMenu.addEventListener("popupshowing", refreshCLMainMenu, true);
  clGoMenu.addEventListener("popupshowing", refreshCLGoMenu, true);
}


function onKeyPress (event) {
    //dump("event.charCode = " + event.charCode + "\n");
    if (document.commandDispatcher.focusedWindow.document.URL) {
        //dump("focused window" + document.commandDispatcher.focusedWindow.document.URL + "\n"); 
        //dump("event.altKey = "   + event.altKey   + "\n" +
        //     "event.ctrlKey = "  + event.ctrlKey  + "\n" +
        //     "event.metaKey = "  + event.metaKey  + "\n" +
        //     "event.shiftKey = " + event.shiftKey + "\n" );
        //dump("navigator.platform = " + navigator.platform + "\n");
        if (navigator.platform == "MacPPC") 
          macosxShortcuts(event);
        else
          windowsLinuxShortcuts(event);
    } 
}

function windowsLinuxShortcuts(event) {
        if ( event.charCode == 99 && event.ctrlKey && 
            !event.altKey && !event.metaKey && !event.shiftKey) 
		{
		    dump("ctrl-C\n");
		    goDoCommand('cmd_copy');
		    handleCopy();
	        event.stopPropagation();
			event.preventDefault();
		}
		else if ( event.charCode == 120 && event.ctrlKey && 
                 !event.altKey && !event.metaKey && !event.shiftKey) 
		{
		    dump("ctrl-X\n");
		    goDoCommand('cmd_cut');
		    handleCut();
	        event.stopPropagation();
			event.preventDefault();
		}
		else if ( event.charCode == 118 && event.ctrlKey && 
                 !event.altKey && !event.metaKey && !event.shiftKey) 
		{
		    dump("ctrl-V\n");
		    goDoCommand('cmd_paste');
		    handlePaste();
	        event.stopPropagation();
			event.preventDefault();
		}
}

function macosxShortcuts(event) {
        if ( event.charCode == 99 && event.metaKey && 
            !event.altKey && !event.ctrlKey && !event.shiftKey) 
		{
		    dump("cmd-C\n");
		    goDoCommand('cmd_copy');
		    handleCopy();
	        event.stopPropagation();
			event.preventDefault();
		}
		else if ( event.charCode == 120 && event.metaKey && 
                 !event.altKey && !event.ctrlKey && !event.shiftKey) 
		{
		    dump("cmd-X\n");
		    goDoCommand('cmd_cut');
		    handleCut();
	        event.stopPropagation();
			event.preventDefault();
		}
		else if ( event.charCode == 118 && event.metaKey && 
                 !event.altKey && !event.ctrlKey && !event.shiftKey) 
		{
		    dump("cmd-V\n");
		    goDoCommand('cmd_paste');
		    handlePaste();
	        event.stopPropagation();
			event.preventDefault();
		}
}